# Function to add two points on the elliptic curve
def point_add(p, q, a, p_field):
    if p is None:
        return q
    if q is None:
        return p
    
    x1, y1 = p
    x2, y2 = q
    
    if p == q:
        m = (3 * x1 * x1 + a) * pow(2 * y1, -1, p_field) % p_field
    else:
        m = (y2 - y1) * pow(x2 - x1, -1, p_field) % p_field
    
    x3 = (m * m - x1 - x2) % p_field
    y3 = (m * (x1 - x3) - y1) % p_field
    
    return x3, y3

# Function to multiply a point by a scalar (fast exponentiation)
def point_multiply(p, scalar, a, p_field):
    result = None
    while scalar > 0:
        if scalar & 1:
            result = point_add(result, p, a, p_field)
        p = point_add(p, p, a, p_field)
        scalar >>= 1
    return result

# Parameters of the elliptic curve y^2 = x^3 + ax + b (mod p)
a = 2
b = 2
p = 17  # A prime number defining the finite field

# Starting point (base point) and order of the group generated by this point
base_point = (5, 1)
order = 19

# Private keys
private_key_A = 7
private_key_B = 13

# Calculation of public keys
public_key_A = point_multiply(base_point, private_key_A, a, p)
public_key_B = point_multiply(base_point, private_key_B, a, p)

# Calculation of the shared secret key (x coordinate of the point multiplication by the private key)
shared_secret_A = point_multiply(public_key_B, private_key_A, a, p)[0]
shared_secret_B = point_multiply(public_key_A, private_key_B, a, p)[0]

print("Shared secret key for A:", shared_secret_A)
print("Shared secret key for B:", shared_secret_B)
